#!/usr/bin/env python

"""
  to test with python

cmd1:env keystore=`pwd` ./id.py 
cmd2:env ABAC_CN=1 keystore=`pwd` ./id.py

"""

import os
import ABAC

ctxt = ABAC.Context()

print "ABAC version %s" % ctxt.version()

keystore=os.environ["keystore"]

ctxt.load_directory(keystore)
out = ctxt.context_principals()
print "...initial principal set..."
for x in out[1]:
    print "%s " % x.string()
print "\n" 

id=ABAC.ID("Mary", 0)
print "adding -> %s(good)" % id.name()
id.write_cert("Mary_ID.pem")
id.write_privkey("Mary_private.pem")
ctxt.load_id_file("Mary_ID.pem","Mary_private.pem")

nid=ABAC.ID("Jack", 0)
print "adding -> %s(good)" % nid.name()
ctxt.load_id(nid)

id=ABAC.ID("Mark", 0)
print "adding -> %s(good)" % id.name()
id.write_privkey("Mark_IDKEY.pem")
id.write_cert("Mark_IDKEY.pem")
ctxt.load_id_file("Mark_IDKEY.pem")

id=ABAC.ID("John", 0)
print "adding -> %s(good,invisible)" % id.name()
id.write_privkey("John_other.pem")
id.write_cert("John_other.pem")
ctxt.load_id_file("John_other.pem")

id=ABAC.ID("Lori", 0)
print "adding -> %s(good,nokey)" % id.name()
id.write_cert("Lori_IDKEY.pem")
ctxt.load_id_file("Lori_IDKEY.pem")

id=ABAC.ID("Tom", 0)
print "adding -> %s(bad,nocert)" % id.name()
id.write_privkey("Tom_IDKEY.pem")
ctxt.load_id_file("Tom_IDKEY.pem")

print "adding -> Casper(bad,unknown file)"
ctxt.load_id_file("Casper_IDKEY.pem")

print "...final principal set..."
out = ctxt.context_principals()
for x in out[1]:
    print "%s " % x.string()
print "\n"

ctxt.dump_yap()
